Index: /trunk/source/Lib/TLibCommon/TComDataCU.cpp
===================================================================
--- /trunk/source/Lib/TLibCommon/TComDataCU.cpp	(revision 1412)
+++ /trunk/source/Lib/TLibCommon/TComDataCU.cpp	(revision 1413)
@@ -3310,22 +3069,5 @@
   if (getAvailableFlagA1())
   {
-    m_mergCands[MRG_A1].setCand( &pcMFieldNeighbours[m_numSpatialCands<<1], puhInterDirNeighbours[m_numSpatialCands]
-#if NH_3D_VSP
-    , (pcCULeft->getVSPFlag(uiLeftPartIdx) != 0
-#if NH_3D_IC
-      && !bICFlag
-#endif
-#if NH_3D_ARP
-      && !bARPFlag
-#endif
-#if NH_3D_DBBP
-      && !bDBBPFlag
-#endif
-      )
-#endif
-#if NH_3D_SPIVMP
-      , false
-#endif
-      ); 
+    m_mergCands[MRG_A1].setCand( &pcMFieldNeighbours[m_numSpatialCands<<1], puhInterDirNeighbours[m_numSpatialCands], (pcCULeft->getVSPFlag(uiLeftPartIdx) != 0 && !bICFlag && !bARPFlag&& !bDBBPFlag), false ); 
     m_numSpatialCands++;
   }
@@ -3334,12 +3076,5 @@
   if (getAvailableFlagB1())
   {
-    m_mergCands[MRG_B1].setCand( &pcMFieldNeighbours[m_numSpatialCands<<1], puhInterDirNeighbours[m_numSpatialCands]
-#if NH_3D_VSP
-    , false
-#endif
-#if NH_3D_SPIVMP
-      , false
-#endif
-      ); 
+    m_mergCands[MRG_B1].setCand( &pcMFieldNeighbours[m_numSpatialCands<<1], puhInterDirNeighbours[m_numSpatialCands], false, false ); 
     m_numSpatialCands++;
   }
@@ -3348,12 +3083,5 @@
   if (getAvailableFlagB0())
   {
-    m_mergCands[MRG_B0].setCand( &pcMFieldNeighbours[m_numSpatialCands<<1], puhInterDirNeighbours[m_numSpatialCands]
-#if NH_3D_VSP
-    , false
-#endif
-#if NH_3D_SPIVMP
-      , false
-#endif
-      ); 
+    m_mergCands[MRG_B0].setCand( &pcMFieldNeighbours[m_numSpatialCands<<1], puhInterDirNeighbours[m_numSpatialCands], false, false ); 
     m_numSpatialCands++;
   }
@@ -3362,12 +3090,5 @@
   if (getAvailableFlagA0())
   {
-    m_mergCands[MRG_A0].setCand( &pcMFieldNeighbours[m_numSpatialCands<<1], puhInterDirNeighbours[m_numSpatialCands]
-#if NH_3D_VSP
-    , false
-#endif
-#if NH_3D_SPIVMP
-      , false
-#endif
-      ); 
+    m_mergCands[MRG_A0].setCand( &pcMFieldNeighbours[m_numSpatialCands<<1], puhInterDirNeighbours[m_numSpatialCands], false, false ); 
     m_numSpatialCands++;
   }
@@ -3376,17 +3097,8 @@
   if (getAvailableFlagB2())
   {
-    m_mergCands[MRG_B2].setCand( &pcMFieldNeighbours[m_numSpatialCands<<1], puhInterDirNeighbours[m_numSpatialCands]
-#if NH_3D_VSP
-    , false
-#endif
-#if NH_3D_SPIVMP
-      , false
-#endif
-      ); 
+    m_mergCands[MRG_B2].setCand( &pcMFieldNeighbours[m_numSpatialCands<<1], puhInterDirNeighbours[m_numSpatialCands], false, false ); 
     m_numSpatialCands++;
   }
 
-
-#if NH_3D_TEXT_MERGE
 
   /////////////////////////////////////////////
@@ -3404,8 +3116,4 @@
 
     TComPic * pcTexPic = m_pcSlice->getTexturePic();
-#if H_3D_FCO
-    if (pcTexPic && pcTexPic->getReconMark())
-    {
-#endif    
       TComPicYuv*   pcTexRec = pcTexPic->getPicYuvRec  ();
       UInt          uiPartAddr;
@@ -3439,7 +3147,6 @@
 
       Int         iTexPosX, iTexPosY;
-#if NH_3D_INTEGER_MV_DEPTH
       const TComMv cMvRounding( 1 << ( 2 - 1 ), 1 << ( 2 - 1 ) );
-#endif
+
       Int         iCenterPosX = iCurrPosX + ( ( iWidth /  iPUWidth ) >> 1 )  * iPUWidth + ( iPUWidth >> 1 );
       Int         iCenterPosY = iCurrPosY + ( ( iHeight /  iPUHeight ) >> 1 )  * iPUHeight + (iPUHeight >> 1);
@@ -3474,10 +3181,6 @@
               {
                 bSPIVMPFlag = true;
-#if NH_3D_INTEGER_MV_DEPTH
                 TComMv cMv = cDefaultMvField.getMv() + cMvRounding;
                 cMv >>= 2;
-#else
-                TComMv cMv = cDefaultMvField.getMv();
-#endif
                 cMvFieldSaved[eCurrRefPicList].setMvField(cMv, iRefPicList) ;
                 break;
@@ -3516,10 +3219,6 @@
                 if( (cTexMvField.getRefIdx()>=0) && ( iValidDepRef >= 0 ) )
                 {
-#if NH_3D_INTEGER_MV_DEPTH
                   TComMv cMv = cTexMvField.getMv() + cMvRounding;
                   cMv >>=2;          
-#else
-                  TComMv cMv = cTexMvField.getMv();
-#endif         
                   pcMvFieldSP[2*iPartition + uiCurrRefListId].setMvField(cMv, iValidDepRef);
                 }
@@ -3541,7 +3240,5 @@
         }
       }
-#if H_3D_FCO
-    }
-#endif
+
     if( tmpDir != 0 )
     {
@@ -3568,7 +3265,5 @@
     }
   }
-#endif
-
-#if NH_3D_IV_MERGE
+
   /////////////////////////////////////////////////////////////////
   //////// DERIVE IvMC, IvMCShift,IvDCShift, IvDC  Candidates /////
@@ -3588,9 +3283,5 @@
   if ( ivMvPredFlag && cDisInfo.m_aVIdxCan!=-1)
   {
-#if NH_3D_IC
     getInterViewMergeCands(uiPUIdx, ivCandRefIdx, ivCandMv, &cDisInfo, ivCandDir , bIsDepth, pcMvFieldSP, puhInterDirSP, bICFlag );
-#else
-    getInterViewMergeCands(uiPUIdx, ivCandRefIdx, ivCandMv, &cDisInfo, ivCandDir , bIsDepth, pcMvFieldSP, puhInterDirSP, false );
-#endif
   }  
 
@@ -3648,7 +3339,5 @@
         spiMvpFlag = true;
       }
-#if NH_3D_DBBP
       spiMvpFlag &= !bDBBPFlag;
-#endif
 
       m_mergCands[MRG_IVMC].setCand( tmpMV, ivCandDir[0], false, spiMvpFlag);
@@ -3667,9 +3356,8 @@
     return;
   }
-#endif
+
 
   iCount += m_mergCands[MRG_A1].m_bAvailable + m_mergCands[MRG_B1].m_bAvailable;
 
-#if NH_3D_VSP
   /////////////////////////////////////////////////
   //////// VIEW SYNTHESIS PREDICTION (VSP) ////////
@@ -3677,18 +3365,9 @@
   if (iCount<getSlice()->getMaxNumMergeCand())
   {
-    if (
-      (!getAvailableFlagA1() || !(pcCULeft->getVSPFlag(uiLeftPartIdx) != 0)) &&
-#if NH_3D_IC
-      !bICFlag &&
-#endif
-#if NH_3D_ARP
-      !bARPFlag &&
-#endif
-#if NH_3D
+    if ( ( !getAvailableFlagA1() || !(pcCULeft->getVSPFlag(uiLeftPartIdx) != 0) ) &&
+      !bICFlag           &&
+      !bARPFlag          &&
       (nPSW + nPSH > 12) &&
-#endif
-#if NH_3D_DBBP
-      !bDBBPFlag &&
-#endif
+      !bDBBPFlag         &&
       xAddVspCand( mrgCandIdx, &cDisInfo, iCount ) )
     {
@@ -3702,9 +3381,7 @@
     }
   }
-#endif
 
   iCount += m_mergCands[MRG_B0].m_bAvailable;
 
-#if NH_3D_IV_MERGE 
   /////////////////////////////////////////////
   //////// INTER VIEW DISP COMP (IvDC) ////////
@@ -3740,8 +3417,6 @@
     if(!bRemoveSpa)
     {
-#if NH_3D_NBDV
       tmpMV[0].getMv().setIDVFlag (false);
       tmpMV[1].getMv().setIDVFlag (false);
-#endif
       m_mergCands[MRG_IVDC].setCand( tmpMV, ivCandDir[1], false, false);
 
@@ -3757,9 +3432,8 @@
     }
   } 
-#endif // H_3D_IV_MERGE 
+
 
   iCount += m_mergCands[MRG_A0].m_bAvailable + m_mergCands[MRG_B2].m_bAvailable;
 
-#if NH_3D_IV_MERGE
   ////////////////////////////////////////////////////
   //////// SHIFTED IV (IvMCShift + IvDCShift) ////////
@@ -3777,17 +3451,21 @@
     }
   }
-#endif
 }
 #endif
 
 //! Construct a list of merging candidates
-#if NH_3D
+
+
+#if MCTS_ENC_CHECK
+Void TComDataCU::getInterMergeCandidates( UInt uiAbsPartIdx, UInt uiPUIdx, TComMvField* pcMvFieldNeighbours, UChar* puhInterDirNeighbours, Int& numValidMergeCand, UInt &numSpatialMergeCandidates, Int mrgCandIdx ) 
+#else
 Void TComDataCU::getInterMergeCandidates( UInt uiAbsPartIdx, UInt uiPUIdx, TComMvField* pcMvFieldNeighbours, UChar* puhInterDirNeighbours, Int& numValidMergeCand, Int mrgCandIdx )
-#else
-Void TComDataCU::getInterMergeCandidates( UInt uiAbsPartIdx, UInt uiPUIdx, TComMvField* pcMvFieldNeighbours, UChar* puhInterDirNeighbours, Int& numValidMergeCand, Int mrgCandIdx ) const
+#endif
+#if !NH_3D  
+  const
 #endif
 {
   UInt uiAbsPartAddr = m_absZIdxInCtu + uiAbsPartIdx;
-#if NH_3D_MLC
+#if NH_3D
   Bool abCandIsInter[ MRG_MAX_NUM_CANDS_MEM ];
 #else
@@ -3823,5 +3501,5 @@
   if ( isAvailableA1 )
   {
-#if NH_3D_MLC
+#if NH_3D
     m_bAvailableFlagA1 = 1;
 #endif
@@ -3837,4 +3515,7 @@
     if ( mrgCandIdx == iCount )
     {
+#if MCTS_ENC_CHECK
+      numSpatialMergeCandidates = iCount + 1;
+#endif
       return;
     }
@@ -3845,4 +3526,7 @@
   if (iCount == getSlice()->getMaxNumMergeCand())
   {
+#if MCTS_ENC_CHECK
+    numSpatialMergeCandidates = iCount;
+#endif
     return;
   }
@@ -3858,5 +3542,5 @@
   if ( isAvailableB1 && (!isAvailableA1 || !pcCULeft->hasEqualMotion( uiLeftPartIdx, pcCUAbove, uiAbovePartIdx ) ) )
   {
-#if NH_3D_MLC
+#if NH_3D
     m_bAvailableFlagB1 = 1;
 #endif
@@ -3872,4 +3556,7 @@
     if ( mrgCandIdx == iCount )
     {
+#if MCTS_ENC_CHECK
+      numSpatialMergeCandidates = iCount + 1;
+#endif
       return;
     }
@@ -3879,4 +3566,7 @@
   if (iCount == getSlice()->getMaxNumMergeCand())
   {
+#if MCTS_ENC_CHECK
+    numSpatialMergeCandidates = iCount;
+#endif
     return;
   }
@@ -3892,5 +3582,5 @@
   if ( isAvailableB0 && ( !isAvailableB1 || !pcCUAbove->hasEqualMotion( uiAbovePartIdx, pcCUAboveRight, uiAboveRightPartIdx ) ) )
   {
-#if NH_3D_MLC
+#if NH_3D
     m_bAvailableFlagB0 = 1;
 #endif
@@ -3906,4 +3596,7 @@
     if ( mrgCandIdx == iCount )
     {
+#if MCTS_ENC_CHECK
+      numSpatialMergeCandidates = iCount + 1;
+#endif
       return;
     }
@@ -3913,4 +3606,7 @@
   if (iCount == getSlice()->getMaxNumMergeCand())
   {
+#if MCTS_ENC_CHECK
+    numSpatialMergeCandidates = iCount;
+#endif
     return;
   }
@@ -3926,5 +3622,5 @@
   if ( isAvailableA0 && ( !isAvailableA1 || !pcCULeft->hasEqualMotion( uiLeftPartIdx, pcCULeftBottom, uiLeftBottomPartIdx ) ) )
   {
-#if NH_3D_MLC
+#if NH_3D
     m_bAvailableFlagA0 = 1;
 #endif
@@ -3940,4 +3636,7 @@
     if ( mrgCandIdx == iCount )
     {
+#if MCTS_ENC_CHECK
+      numSpatialMergeCandidates = iCount + 1;
+#endif
       return;
     }
@@ -3947,4 +3646,7 @@
   if (iCount == getSlice()->getMaxNumMergeCand())
   {
+#if MCTS_ENC_CHECK
+    numSpatialMergeCandidates = iCount;
+#endif
     return;
   }
@@ -3963,5 +3665,5 @@
         && ( !isAvailableB1 || !pcCUAbove->hasEqualMotion( uiAbovePartIdx, pcCUAboveLeft, uiAboveLeftPartIdx ) ) )
     {
-#if NH_3D_MLC
+#if NH_3D
       m_bAvailableFlagB2 = 1;
 #endif
@@ -3977,4 +3679,7 @@
       if ( mrgCandIdx == iCount )
       {
+#if MCTS_ENC_CHECK
+        numSpatialMergeCandidates = iCount + 1;
+#endif
         return;
       }
@@ -3985,7 +3690,13 @@
   if (iCount == getSlice()->getMaxNumMergeCand())
   {
+#if MCTS_ENC_CHECK
+    numSpatialMergeCandidates = iCount;
+#endif
     return;
   }
 
+#if MCTS_ENC_CHECK
+  numSpatialMergeCandidates = iCount;
+#endif
   if ( getSlice()->getEnableTMVPFlag() )
   {
@@ -4047,5 +3758,5 @@
     if ( getSlice()->isInterB() )
     {
-#if NH_3D_TMVP
+#if NH_3D
       iRefIdx = 0;
 #endif
@@ -4066,5 +3777,5 @@
       puhInterDirNeighbours[uiArrayAddr] = dir;
       abCandIsInter[uiArrayAddr] = true;
-#if NH_3D_NBDV
+#if NH_3D
       pcMvFieldNeighbours[iCount<<1    ].getMv().setIDVFlag (false);
       pcMvFieldNeighbours[(iCount<<1)+1].getMv().setIDVFlag (false);
@@ -4087,5 +3798,5 @@
   UInt uiCutoff = uiArrayAddr;
 
-#if NH_3D_MLC
+#if NH_3D
   if ( getSlice()->isInterB() && iCount<5)
 #else
@@ -4257,4 +3968,7 @@
   if (refIdx < 0)
   {
+#if MCTS_ENC_CHECK
+    pInfo->numSpatialMVPCandidates = 0;
+#endif
     return;
   }
@@ -4329,4 +4043,7 @@
   }
 
+#if MCTS_ENC_CHECK
+  pInfo->numSpatialMVPCandidates = pInfo->iN;
+#endif
   if (pInfo->iN < AMVP_MAX_NUM_CANDS && getSlice()->getEnableTMVPFlag() )
   {
@@ -4334,5 +4051,5 @@
     const UInt numPartInCtuWidth  = m_pcPic->getNumPartInCtuWidth();
     const UInt numPartInCtuHeight = m_pcPic->getNumPartInCtuHeight();
-#if NH_3D_TMVP
+#if NH_3D
     Int refIdx_Col = refIdx;
 #else
@@ -4372,5 +4089,5 @@
       }
     }
-#if NH_3D_TMVP
+#if NH_3D
         if ( ctuRsAddr >= 0 && xGetColMVP( eRefPicList, ctuRsAddr, absPartAddr, cColMv, refIdx_Col  , 0 ) )
 #else
@@ -4384,5 +4101,5 @@
       UInt uiPartIdxCenter;
       xDeriveCenterIdx( partIdx, uiPartIdxCenter );
-#if NH_3D_TMVP
+#if NH_3D
       if (xGetColMVP( eRefPicList, getCtuRsAddr(), uiPartIdxCenter,  cColMv, refIdx_Col , 0 )) 
 #else
@@ -4411,5 +4128,5 @@
   UInt partAddr;
 
-#if NH_3D_DBBP
+#if NH_3D
   if( getDBBPFlag(0) )
   {
@@ -4431,5 +4148,5 @@
   const TComSPS &sps=*(m_pcSlice->getSPS());
   Int  iMvShift = 2;
-#if NH_3D_INTEGER_MV_DEPTH
+#if NH_3D
   if( getSlice()->getIsDepth() )
     iMvShift = 0;
@@ -4663,5 +4380,5 @@
 }
 
-#if NH_3D_TMVP
+#if NH_3D
 Bool TComDataCU::xGetColMVP( const RefPicList eRefPicList, const Int ctuRsAddr, const Int partUnitIdx, TComMv& rcMv, Int& refIdx, Bool bMRG  ) const
 #else
@@ -4673,11 +4390,25 @@
   // use coldir.
   const TComPic    * const pColPic = getSlice()->getRefPic( RefPicList(getSlice()->isInterB() ? 1-getSlice()->getColFromL0Flag() : 0), getSlice()->getColRefIdx());
+#if REDUCED_ENCODER_MEMORY
+  if (!pColPic->getPicSym()->hasDPBPerCtuData())
+  {
+    return false;
+  }
+  const TComPicSym::DPBPerCtuData * const pColDpbCtu = &(pColPic->getPicSym()->getDPBPerCtuData(ctuRsAddr));
+  const TComSlice * const pColSlice = pColDpbCtu->getSlice();
+  if(pColDpbCtu->getPartitionSize(partUnitIdx)==NUMBER_OF_PART_SIZES)
+#else
   const TComDataCU * const pColCtu = pColPic->getCtu( ctuRsAddr );
   if(pColCtu->getPic()==0 || pColCtu->getPartitionSize(partUnitIdx)==NUMBER_OF_PART_SIZES)
+#endif
   {
     return false;
   }
 
+#if REDUCED_ENCODER_MEMORY
+  if (!pColDpbCtu->isInter(absPartAddr))
+#else
   if (!pColCtu->isInter(absPartAddr))
+#endif
   {
     return false;
@@ -4685,10 +4416,18 @@
 
   RefPicList eColRefPicList = getSlice()->getCheckLDC() ? eRefPicList : RefPicList(getSlice()->getColFromL0Flag());
+#if REDUCED_ENCODER_MEMORY
+  Int iColRefIdx            = pColDpbCtu->getCUMvField(RefPicList(eColRefPicList))->getRefIdx(absPartAddr);
+#else
   Int iColRefIdx            = pColCtu->getCUMvField(RefPicList(eColRefPicList))->getRefIdx(absPartAddr);
+#endif
 
   if (iColRefIdx < 0 )
   {
     eColRefPicList = RefPicList(1 - eColRefPicList);
+#if REDUCED_ENCODER_MEMORY
+    iColRefIdx = pColDpbCtu->getCUMvField(RefPicList(eColRefPicList))->getRefIdx(absPartAddr);
+#else
     iColRefIdx = pColCtu->getCUMvField(RefPicList(eColRefPicList))->getRefIdx(absPartAddr);
+#endif
 
     if (iColRefIdx < 0 )
@@ -4698,14 +4437,17 @@
   }
 
-#if NH_3D_TMVP
+#if NH_3D
   Bool bIsCurrRefLongTerm = m_pcSlice->getRefPic(eRefPicList, refIdx)->getIsLongTerm();
 #else
   const Bool bIsCurrRefLongTerm = m_pcSlice->getRefPic(eRefPicList, refIdx)->getIsLongTerm();
 #endif
+#if REDUCED_ENCODER_MEMORY
+  const Bool bIsColRefLongTerm  = pColSlice->getIsUsedAsLongTerm(eColRefPicList, iColRefIdx);
+#else
   const Bool bIsColRefLongTerm  = pColCtu->getSlice()->getIsUsedAsLongTerm(eColRefPicList, iColRefIdx);
-
+#endif
   if ( bIsCurrRefLongTerm != bIsColRefLongTerm )
   {
-#if NH_3D_TMVP
+#if NH_3D
     Int iAlterRefIdx  = m_pcSlice->getAlterRefIdx(eRefPicList);
     if(bMRG && iAlterRefIdx > 0)
@@ -4719,12 +4461,16 @@
 #endif
       return false;
-#if NH_3D_TMVP
+#if NH_3D
     }
 #endif
   }
   // Scale the vector.
+#if REDUCED_ENCODER_MEMORY
+  const TComMv &cColMv = pColDpbCtu->getCUMvField(eColRefPicList)->getMv(absPartAddr);
+#else
   const TComMv &cColMv = pColCtu->getCUMvField(eColRefPicList)->getMv(absPartAddr);
-
-#if NH_3D_TMVP
+#endif
+
+#if NH_3D
   if ( bIsCurrRefLongTerm || bIsColRefLongTerm )
 #else
@@ -4732,5 +4478,5 @@
 #endif
   {
-#if NH_3D_TMVP
+#if NH_3D
     const Int iCurrViewId    = m_pcSlice->getViewId (); 
     const Int iCurrRefViewId = m_pcSlice->getRefPic(eRefPicList, refIdx)->getViewId (); 
@@ -4750,5 +4496,5 @@
 #endif
       rcMv = cColMv;
-#if NH_3D_TMVP
+#if NH_3D
     }
 #endif
@@ -4757,6 +4503,11 @@
   {
     const Int currPOC    = m_pcSlice->getPOC();
+#if REDUCED_ENCODER_MEMORY
+    const Int colPOC     = pColSlice->getPOC();
+    const Int colRefPOC  = pColSlice->getRefPOC(eColRefPicList, iColRefIdx);
+#else
     const Int colPOC     = pColCtu->getSlice()->getPOC();
     const Int colRefPOC  = pColCtu->getSlice()->getRefPOC(eColRefPicList, iColRefIdx);
+#endif
     const Int currRefPOC = m_pcSlice->getRefPic(eRefPicList, refIdx)->getPOC();
     const Int scale      = xGetDistScaleFactor(currPOC, currRefPOC, colPOC, colRefPOC);
@@ -4811,9 +4562,27 @@
 {
    Int scaleFactor = (4 / scale ) * AMVP_DECIMATION_FACTOR / m_unitSize;
+  if (scaleFactor > 0)
+  {
+    for(UInt i=0; i<NUM_REF_PIC_LIST_01; i++)
+    {
+      m_acCUMvField[i].compress(m_pePredMode, scaleFactor);
+    }
+  }
 #else
 Void TComDataCU::compressMV()
 {
+#if REDUCED_ENCODER_MEMORY
+  const Int scaleFactor = std::max<Int>(1,4 * AMVP_DECIMATION_FACTOR / m_unitSize);
+  TComPicSym &picSym=*(getPic()->getPicSym());
+  TComPicSym::DPBPerCtuData &dpbForCtu=picSym.getDPBPerCtuData(getCtuRsAddr());
+
+  for(UInt i=0; i<NUM_REF_PIC_LIST_01; i++)
+  {
+    dpbForCtu.m_CUMvField[i].compress(dpbForCtu.m_pePredMode, m_pePredMode, scaleFactor,m_acCUMvField[i]);
+    memcpy(dpbForCtu.m_pePartSize, m_pePartSize, sizeof(*m_pePartSize)*m_uiNumPartition);
+    dpbForCtu.m_pSlice = getSlice();
+  }
+#else
   Int scaleFactor = 4 * AMVP_DECIMATION_FACTOR / m_unitSize;
-#endif
   if (scaleFactor > 0)
   {
@@ -4823,4 +4592,6 @@
     }
   }
+#endif
+#endif
 }
 #if NH_3D
@@ -4867,5 +4638,5 @@
 
   UInt uiDirMode  = getIntraDir(toChannelType(compID), uiAbsPartIdx);
-#if NH_3D_DMM
+#if NH_3D
   mapDmmToIntraDir( uiDirMode );
 #endif
@@ -4876,5 +4647,5 @@
     const UInt partsPerMinCU = 1<<(2*(sps->getMaxTotalCUDepth() - sps->getLog2DiffMaxMinCodingBlockSize()));
     uiDirMode = getIntraDir(CHANNEL_TYPE_LUMA, getChromasCorrespondingPULumaIdx(uiAbsPartIdx, getPic()->getChromaFormat(), partsPerMinCU));
-#if NH_3D_DMM
+#if NH_3D
     mapDmmToIntraDir( uiDirMode );
 #endif
@@ -4901,4 +4672,17 @@
   }
 }
+
+#if MCTS_ENC_CHECK
+Bool TComDataCU::isLastColumnCTUInTile() const
+{
+  UInt      currentTileIdx               = this->getPic()->getPicSym()->getTileIdxMap(this->getCtuRsAddr());
+  TComTile *pCurrentTile                 = m_pcPic->getPicSym()->getTComTile(currentTileIdx);
+  UInt      frameWidthInCtus             = m_pcPic->getPicSym()->getFrameWidthInCtus();
+  UInt      rightEdgeCTUPosInCurrentTile = pCurrentTile->getRightEdgePosInCtus();
+  UInt      ctuXPosInCtus                = this->getCtuRsAddr() % frameWidthInCtus;
+  
+  return (rightEdgeCTUPosInCurrentTile == ctuXPosInCtus);
+}
+#endif
 
 #if NH_3D_VSO
@@ -4910,5 +4694,5 @@
 #endif
 
-#if NH_3D_IV_MERGE
+#if NH_3D
 Void TComDataCU::getDispforDepth (UInt uiPartIdx, UInt uiPartAddr, DisInfo* pDisp)
 {
@@ -4928,7 +4712,5 @@
   }
 }
-#endif
-
-#if NH_3D_DIS
+
 Bool TComDataCU::getNeighDepth ( UInt uiPartIdx, UInt uiPartAddr, Pel* pNeighDepth, Int index )
 {
@@ -4988,15 +4770,6 @@
   return bDepAvail;
 }
-#endif
-#if NH_3D_NBDV 
-//Notes from QC:
-//TBD#1: DoNBDV related contributions are just partially integrated under the marco of NH_3D_NBDV_REF, remove this comment once DoNBDV and BVSP are done
-//TBD#2: set of DvMCP values need to be done as part of inter-view motion prediction process. Remove this comment once merge related integration is done
-//To be checked: Parallel Merge features for NBDV, related to DV_DERIVATION_PARALLEL_B0096 and LGE_IVMP_PARALLEL_MERGE_B0136 are not integrated. The need of these features due to the adoption of CU-based NBDV is not clear. We need confirmation on this, especially by proponents
-Void TComDataCU::getDisMvpCandNBDV( DisInfo* pDInfo
-#if NH_3D_NBDV_REF
-, Bool bDepthRefine
-#endif
-)
+
+Void TComDataCU::getDisMvpCandNBDV( DisInfo* pDInfo, Bool bDepthRefine )
 {
   //// ******* Init variables ******* /////
@@ -5018,10 +4791,10 @@
     }
   }
-#if NH_3D_NBDV_REF
+
   if( !m_pcSlice->getDepthRefinementFlag( ) )
   {
     bDepthRefine = false;
   }
-#endif
+
   // Get Positions  
   PartSize eCUMode    = getPartitionSize( uiPartAddr );    
@@ -5068,21 +4841,6 @@
         pDInfo->m_aVIdxCan  = iTargetViewIdx;
 
-#if NH_3D_NBDV_REF
         TComPic* picDepth = NULL;   
-#if H_3D_FCO
-        picDepth  = getSlice()->getIvPic(true, getSlice()->getViewIndex() );
-        if ( picDepth->getPicYuvRec() != NULL  )  
-        {
-          cColMv.setZero();
-        }
-        else // Go back with virtual depth
-        {
-          picDepth = getSlice()->getIvPic( true, iTargetViewIdx );
-        }
-
-        assert(picDepth != NULL);
-#else
         picDepth = getSlice()->getIvPic( true, iTargetViewIdx );
-#endif
         if (picDepth && bDepthRefine)
         {
@@ -5090,5 +4848,4 @@
         }
         pDInfo->m_acDoNBDV  = cColMv;
-#endif //NH_3D_NBDV_REF
         return;
       }
@@ -5103,9 +4860,5 @@
     pcTmpCU = getPULeft(uiIdx, uiPartIdxLB);
   bCheckMcpDv = true; 
-  if ( xCheckSpatialNBDV( pcTmpCU, uiIdx, pDInfo, bCheckMcpDv, &cIDVInfo, DVFROM_LEFT
-#if NH_3D_NBDV_REF
-    , bDepthRefine 
-#endif
-    ) )
+  if ( xCheckSpatialNBDV( pcTmpCU, uiIdx, pDInfo, bCheckMcpDv, &cIDVInfo, DVFROM_LEFT, bDepthRefine ) )
     return;
 
@@ -5115,9 +4868,5 @@
   {
     bCheckMcpDv = ( ( getCtuRsAddr() - pcTmpCU->getCtuRsAddr() ) == 0);
-    if ( xCheckSpatialNBDV( pcTmpCU, uiIdx, pDInfo, bCheckMcpDv, &cIDVInfo, DVFROM_ABOVE
-#if NH_3D_NBDV_REF
-      , bDepthRefine 
-#endif
-      ) )
+    if ( xCheckSpatialNBDV( pcTmpCU, uiIdx, pDInfo, bCheckMcpDv, &cIDVInfo, DVFROM_ABOVE , bDepthRefine ) )
       return;
   }
@@ -5135,22 +4884,5 @@
           pDInfo->m_acNBDV = cDispVec;
           pDInfo->m_aVIdxCan = cIDVInfo.m_aVIdxCan[iList][ curPos ];
-#if NH_3D_NBDV_REF
-#if H_3D_FCO
-          TComPic* picDepth  = NULL;
-
-          picDepth  = getSlice()->getIvPic(true, getSlice()->getViewIndex() );
-          if ( picDepth->getPicYuvRec() != NULL )  
-          {
-            cDispVec.setZero();
-          }
-          else // Go back with virtual depth
-          {
-            picDepth = getSlice()->getIvPic( true, pDInfo->m_aVIdxCan );
-          }
-
-          assert(picDepth != NULL);
-#else
           TComPic* picDepth = getSlice()->getIvPic( true, pDInfo->m_aVIdxCan );
-#endif
 
           if (picDepth && bDepthRefine)
@@ -5159,5 +4891,4 @@
           }
           pDInfo->m_acDoNBDV = cDispVec;
-#endif
           return;
         }
@@ -5173,21 +4904,6 @@
     pDInfo->m_aVIdxCan = getSlice()->getDefaultRefViewIdx();
 
-#if NH_3D_NBDV_REF
     TComPic* picDepth = NULL;
-#if H_3D_FCO
-    picDepth  = getSlice()->getIvPic(true, getSlice()->getViewIndex() );
-    if ( picDepth->getPicYuvRec() != NULL )  
-    {
-      defaultDV.setZero();
-    }
-    else // Go back with virtual depth
-    {
-      picDepth = getSlice()->getIvPic( true, getSlice()->getDefaultRefViewIdx());
-    }
-
-    assert(picDepth != NULL);
-#else
     picDepth = getSlice()->getIvPic( true, getSlice()->getDefaultRefViewIdx());
-#endif
     if (picDepth && bDepthRefine)
     {
@@ -5195,9 +4911,7 @@
     }
     pDInfo->m_acDoNBDV = defaultDV;
-#endif
-  }
-}
-
-#if NH_3D_NBDV_REF
+  }
+}
+
 Pel TComDataCU::getMcpFromDM(TComPicYuv* pcBaseViewDepthPicYuv, TComMv* mv, Int iBlkX, Int iBlkY, Int iBlkWidth, Int iBlkHeight, Int* aiShiftLUT )
 {
@@ -5241,12 +4955,8 @@
   }
 }
-#endif //NH_3D_NBDV_REF
-
-
-Bool TComDataCU::xCheckSpatialNBDV( const TComDataCU* pcTmpCU, UInt uiIdx, DisInfo* pNbDvInfo, Bool bSearchForMvpDv, IDVInfo* paIDVInfo, UInt uiMvpDvPos
-#if NH_3D_NBDV_REF
-, Bool bDepthRefine 
-#endif
-)
+
+
+
+Bool TComDataCU::xCheckSpatialNBDV( const TComDataCU* pcTmpCU, UInt uiIdx, DisInfo* pNbDvInfo, Bool bSearchForMvpDv, IDVInfo* paIDVInfo, UInt uiMvpDvPos, Bool bDepthRefine )
 {
   if( pcTmpCU != NULL && !pcTmpCU->isIntra( uiIdx ) )
@@ -5266,21 +4976,8 @@
           pNbDvInfo->m_acNBDV = cMvPred;
           pNbDvInfo->m_aVIdxCan = refViewIdx;
-#if NH_3D_NBDV_REF
+
           TComPic* picDepth = NULL;
           assert(getSlice()->getRefPic(eRefPicList, refId)->getPOC() == getSlice()->getPOC());            
-#if H_3D_FCO
-          picDepth  = getSlice()->getIvPic(true, getSlice()->getViewIndex() );
-          if ( picDepth->getPicYuvRec() != NULL )  
-          {
-            cMvPred.setZero();
-          }
-          else// Go back with virtual depth
-          {
-            picDepth = getSlice()->getIvPic (true, refViewIdx );
-          }
-          assert(picDepth != NULL);
-#else
           picDepth   = getSlice()->getIvPic (true, refViewIdx );
-#endif
           UInt uiPartIdx = 0;   //Notes from MTK: Please confirm that using 0 as partition index and partition address is correct for CU-level DoNBDV
           UInt uiPartAddr = 0;  //QC: confirmed
@@ -5291,5 +4988,4 @@
           }
           pNbDvInfo->m_acDoNBDV = cMvPred;
-#endif
           return true;
         }
@@ -5355,14 +5051,9 @@
 }
 
-
 Void TComDataCU::setDvInfoSubParts( DisInfo cDvInfo, UInt uiAbsPartIdx, UInt uiDepth )
 {
-#if NH_3D_VSP // bug fix
   UInt uiCurrPartNumb = m_pcPic->getNumPartitionsInCtu() >> (uiDepth << 1);
   assert(m_pcPic->getNumPartitionsInCtu() ==m_pcPic->getNumPartInCtuWidth()*m_pcPic->getNumPartInCtuHeight());
 
-#else
-  UInt uiCurrPartNumb = m_pcPic->getNumPartInCtuWidth() >> (uiDepth << 1);
-#endif
   for (UInt ui = 0; ui < uiCurrPartNumb; ui++ )
   {
@@ -5370,10 +5061,9 @@
   }
 }
-#if NH_3D_VSP  || NH_3D_DBBP
+
 Void TComDataCU::setDvInfoSubParts( DisInfo cDvInfo, UInt uiAbsPartIdx, UInt uiPUIdx, UInt uiDepth )
 {
   setSubPartT<DisInfo>( cDvInfo, m_pDvInfo, uiAbsPartIdx, uiDepth, uiPUIdx );
 }
-#endif
 
 Bool TComDataCU::xGetColDisMV( Int currCandPic, RefPicList eRefPicList, Int refidx, Int uiCUAddr, Int uiPartUnitIdx, TComMv& rcMv , Int & iTargetViewIdx, Int & iStartViewIdx )
@@ -5449,8 +5139,5 @@
   iCurrPosY  += ( ( iHeight - 1 ) >> 1 );
 
-  Bool depthRefineFlag = false; 
-#if NH_3D_NBDV_REF
-  depthRefineFlag = m_pcSlice->getDepthRefinementFlag( ); 
-#endif // NH_3D_NBDV_REF
+  Bool depthRefineFlag = m_pcSlice->getDepthRefinementFlag( ); 
 
   TComMv      cDv = depthRefineFlag ? pDInfo->m_acDoNBDV : pDInfo->m_acNBDV; 
@@ -5506,5 +5193,5 @@
 #endif
 
-#if NH_3D_SPIVMP
+#if NH_3D
 Void TComDataCU::getSPPara(Int iPUWidth, Int iPUHeight, Int& iNumSP, Int& iNumSPInOneLine, Int& iSPWidth, Int& iSPHeight)
 {
@@ -5555,14 +5242,6 @@
   }
 }
-#endif
-
-#if NH_3D_IV_MERGE
-Bool
-TComDataCU::getInterViewMergeCands(UInt uiPartIdx, Int* paiPdmRefIdx, TComMv* pacPdmMv, DisInfo* pDInfo, Int* availableMcDc , Bool bIsDepth           
-#if NH_3D_SPIVMP
-, TComMvField* pcMvFieldSP, UChar* puhInterDirSP
-#endif
-, Bool bICFlag
-)
+
+Bool TComDataCU::getInterViewMergeCands(UInt uiPartIdx, Int* paiPdmRefIdx, TComMv* pacPdmMv, DisInfo* pDInfo, Int* availableMcDc , Bool bIsDepth , TComMvField* pcMvFieldSP, UChar* puhInterDirSP, Bool bICFlag )
 {
   TComSlice*    pcSlice = getSlice ();  
@@ -5581,13 +5260,5 @@
   pcBaseRec->getTopLeftSamplePos( getCtuRsAddr(), getZorderIdxInCtu() + uiPartAddr, iCurrPosX, iCurrPosY );
 
-#if !NH_3D_SPIVMP
-  iCurrPosX  += ( iWidth  >> 1 );
-  iCurrPosY  += ( iHeight >> 1 );
-#endif
-
-  Bool depthRefineFlag = false; 
-#if NH_3D_NBDV_REF
-  depthRefineFlag = m_pcSlice->getDepthRefinementFlag( ); 
-#endif // NH_3D_NBDV_REF
+  Bool depthRefineFlag =  m_pcSlice->getDepthRefinementFlag( ); 
 
   TComMv      cDv = depthRefineFlag ? pDInfo->m_acDoNBDV : pDInfo->m_acNBDV; 
@@ -5598,15 +5269,12 @@
 
   Bool abPdmAvailable[8] =  {false, false, false, false, false, false, false, false};
-#if NH_3D_NBDV
+
   for( Int i = 0; i < 8; i++)
   {
     pacPdmMv[i].setIDVFlag   (false);
   }
-#endif
 
   if(!bICFlag)
   {
-
-#if NH_3D_SPIVMP
     ////////////////////////////////
     //////////sub-PU IvMC///////////
@@ -5614,9 +5282,5 @@
     if(!m_pcSlice->getIsDepth())
     {
-#if NH_3D_DBBP
       if (!getDBBPFlag(0))
-#else
-      if (1)
-#endif
       {
         Int iNumSPInOneLine, iNumSP, iSPWidth, iSPHeight;
@@ -5678,17 +5342,11 @@
                       abPdmAvailable[ uiCurrRefListId ] = true;
                       TComMv cMv(cDefaultMvField.getHor(), cDefaultMvField.getVer());
-#if NH_3D_NBDV 
-#if NH_3D_IV_MERGE
                       if( !bIsDepth )
                       {
-#endif
                         cMv.setIDVFlag   (true);
                         cMv.setIDVHor    (cDv.getHor());                  
                         cMv.setIDVVer    (cDv.getVer());  
                         cMv.setIDVVId    (iViewIndex); 
-#if NH_3D_IV_MERGE
                       }
-#endif
-#endif
                       paiPdmRefIdx  [ uiCurrRefListId ] = iPdmRefIdx;
                       pacPdmMv      [ uiCurrRefListId ] = cMv;
@@ -5778,5 +5436,5 @@
       iCurrPosY  += ( iHeight >> 1 );
     }
-#endif
+
 
     ////////////////////////////////
@@ -5784,5 +5442,4 @@
     ////////////////////////////////
 
-#if NH_3D_SPIVMP
     if(m_pcSlice->getIsDepth())
     {
@@ -5790,12 +5447,6 @@
       iCurrPosY  += ( iHeight >> 1 );
     }
-#if NH_3D_DBBP
+
     for(Int iLoopCan = ( (m_pcSlice->getIsDepth() || getDBBPFlag(0)) ? 0 : 1 ); iLoopCan < ( 2 - m_pcSlice->getIsDepth() ); iLoopCan ++) 
-#else
-    for(Int iLoopCan = ( m_pcSlice->getIsDepth() ? 0 : 1 ); iLoopCan < ( 2 - m_pcSlice->getIsDepth() ); iLoopCan ++) 
-#endif
-#else
-    for(Int iLoopCan = 0; iLoopCan < 2; iLoopCan ++)
-#endif
     {
       // iLoopCan == 0 --> IvMC
@@ -5839,17 +5490,11 @@
                     abPdmAvailable[ (uiCurrRefListId + (iLoopCan<<2)) ] = true;
                     TComMv cMv(cBaseMvField.getHor(), cBaseMvField.getVer());
-#if NH_3D_NBDV 
-#if NH_3D_IV_MERGE
                     if( !bIsDepth )
                     {
-#endif
                       cMv.setIDVFlag   (true);
                       cMv.setIDVHor    (cDv.getHor());                  
                       cMv.setIDVVer    (cDv.getVer());  
                       cMv.setIDVVId    (iViewIndex); 
-#if NH_3D_IV_MERGE
                     }
-#endif
-#endif
                     paiPdmRefIdx  [ (uiCurrRefListId + (iLoopCan<<2)) ] = iPdmRefIdx;
                     pacPdmMv      [ (uiCurrRefListId + (iLoopCan<<2)) ] = cMv;
@@ -5864,13 +5509,5 @@
       }
     }
-#if NH_3D_SPIVMP
-#if NH_3D_DBBP
     for(Int iLoopCan = ( (m_pcSlice->getIsDepth() || getDBBPFlag(0)) ? 0 : 1 ); iLoopCan < ( 2 - m_pcSlice->getIsDepth() ); iLoopCan ++)
-#else
-    for(Int iLoopCan = ( m_pcSlice->getIsDepth()  ? 0 : 1 ); iLoopCan < ( 2 - m_pcSlice->getIsDepth() ); iLoopCan ++)
-#endif
-#else
-    for(Int iLoopCan = 0; iLoopCan < 2; iLoopCan ++)
-#endif
     {
       availableMcDc[(iLoopCan << 1)] = ( abPdmAvailable[(iLoopCan<<2)] ? 1 : 0 ) + ( abPdmAvailable[1 + (iLoopCan<<2)] ? 2 : 0);
@@ -5898,14 +5535,10 @@
             abPdmAvailable[ iRefListId + 2 + (iLoopCan<<2) ] = true;
             paiPdmRefIdx  [ iRefListId + 2 + (iLoopCan<<2) ] = iPdmRefIdx;
-#if NH_3D_NBDV_REF
             TComMv cMv = depthRefineFlag ? pDInfo->m_acDoNBDV : pDInfo->m_acNBDV; 
-#endif
             cMv.setHor( cMv.getHor() + ioffsetDV );
-#if NH_3D_IV_MERGE 
             if( bIsDepth )
             {
               cMv.setHor((cMv.getHor()+2)>>2); 
             }
-#endif
             cMv.setVer( 0 );
             pacPdmMv      [iRefListId + 2 + (iLoopCan<<2)] = cMv;
@@ -5922,13 +5555,10 @@
   return false;
 }
-#endif
-#if NH_3D_ARP
+
 Void TComDataCU::setARPWSubParts ( UChar w, UInt uiAbsPartIdx, UInt uiDepth )
 {
   setSubPart<UChar>( w, m_puhARPW, uiAbsPartIdx, uiDepth, 0 );
 }
-#endif
-
-#if NH_3D_IC
+
 Void TComDataCU::setICFlagSubParts( Bool bICFlag, UInt uiAbsPartIdx, UInt uiPartIdx, UInt uiDepth )
 {
@@ -5983,6 +5613,5 @@
   return false;
 }
-#endif
-#if NH_3D_DMM
+
 Void TComDataCU::setDmm1WedgeTabIdxSubParts( UInt tabIdx, UInt uiAbsPartIdx, UInt uiDepth )
 {
@@ -5990,7 +5619,5 @@
   for( UInt ui = 0; ui < uiCurrPartNumb; ui++ ) { m_dmm1WedgeTabIdx[uiAbsPartIdx+ui] = tabIdx; }
 }
-#endif
-
-#if NH_3D_VSP
+
 Void TComDataCU::setMvFieldPUForVSP( TComDataCU* pcCU, UInt partAddr, Int width, Int height, RefPicList eRefPicList, Int iRefIdx, Int &vspSize )
 {
